package com.parseSystem.event.impl;

import com.alibaba.fastjson2.JSONObject;
import com.dragon.common.redis.service.RedisService;
import com.parseSystem.event.EventHandlerService;
import com.parseSystem.event.VehicleEventService;
import com.parseSystem.vehicle.VehicleData;
import org.springframework.amqp.rabbit.core.RabbitTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;

import javax.xml.crypto.Data;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.concurrent.TimeUnit;

/**
 *
 * 实时轨迹
 * @author 冯凯
 * @version 1.0
 * @description: 实时轨迹事假
 * @date 2023/11/27 20:58
 */
@Service("runtimeTraceEvent")
public class RuntimeTraceEvent extends EventHandlerService implements VehicleEventService {
    @Autowired
    private RedisService redisService;

    /**
     * 实时轨迹事件执行逻辑
     * @param vehicleData
     */
    @Override
    public void executeEvent(VehicleData vehicleData) {
        redisService.setCacheObject("runtimeTraceEvent_"+vehicleData.getVin(),vehicleData);
    }
}
