package com.parseSystem.kafka.ConsumerConfig;

import com.parseSystem.storage.service.StorageDateService;
import org.apache.kafka.clients.consumer.KafkaConsumer;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.stereotype.Component;

import java.util.Properties;

/**
 * @author 冯凯
 * @version 1.0
 * @description: kafka消费者配置
 * @date 2023/11/25 15:37
 */
@Component
public class KafkaConsumerConfig {


    @Bean
    public KafkaConsumer<String, String> consumerInit() {

        KafkaConsumer<String, String> consumer;
        Properties properties = new Properties();
        properties.put("bootstrap.servers", "117.72.43.22:9092");
        properties.put("key.deserializer", "org.apache.kafka.common.serialization.StringDeserializer");
        properties.put("value.deserializer", "org.apache.kafka.common.serialization.StringDeserializer");
        properties.put("partitioner.class", "com.parseSystem.kafka.ConsumerConfig.MyPartitioner");
        consumer = new KafkaConsumer<>(properties);
        return consumer;
    }


}
