package com.parseSystem.utils.eventRuleJudge;

import java.awt.geom.Point2D;
import java.util.List;
 /**
  *  电子围栏判定规则类
  */
public class PolygonUtil {
    /**
     * 发现给定点是否在给定多边形内
     * @param point 给定点
     * @param pts 给定的多边形顶点列表
     * @return 如果给定点在多边形内，则返回true；否则返回false
     */
    public static boolean isInPolygon(Point2D.Double point, List<Point2D.Double> pts){
        int N = pts.size();
        boolean boundOrVertex = true;
        int intersectCount = 0;//交叉点数量
        double precision = 2e-10;//浮点类型计算时候与0比较时候的容差
        Point2D.Double p1, p2;//临近顶点
        Point2D.Double p = point; //当前点

        p1 = pts.get(0);
        for (int i = 1; i <= N; i++) {
            if(p.equals(p1)){
                return boundOrVertex;
            }

            p2 = pts.get(i % N);
            if(p.x < Math.min(p1.x,p2.x) || p.x > Math.max(p1.x, p2.x)){
                p1=p2;
                continue;
            }

            //射线穿过算法
            if(p.x > Math.min(p1.x, p2.x) && p.x < Math.max(p1.x, p2.x)){
                if(p.y <= Math.max(p1.y, p2.y)){
                    if(p1.x == p2.x && p.y >= Math.min(p1.y, p2.y)){
                        return boundOrVertex;
                    }

                    if(p1.y == p2.y){
                        if(p1.y == p.y){
                            return boundOrVertex;
                        }else{
                            ++intersectCount;
                        }
                    }else{
                        double xinters = (p.x - p1.x) * (p2.y - p1.y) / (p2.x - p1.x) + p1.y;
                        if(Math.abs(p.y - xinters) < precision){
                            return boundOrVertex;
                        }

                        if(p.y < xinters){
                            ++intersectCount;
                        }
                    }
                }
            }else{
                if(p.x == p2.x && p.y <= p2.y){
                    Point2D.Double p3 = pts.get((i+1) % N);

                    if(p.x >= Math.min(p1.x, p3.x) && p.x <= Math.max(p1.x, p3.x)){
                       ++intersectCount;
                       intersectCount += 2 ;
                    }
                }
            }
            p1 = p2;
        }
        if (intersectCount % 2 ==0){
            return false;
        }else {
            return true;
        }
    }


}
